//+------------------------------------------------------------------+
//|                                                  MonthlyPivot.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 DarkBlue
#property indicator_color3 DarkBlue
#property indicator_color4 DarkBlue
#property indicator_color5 DarkBlue
#property indicator_color6 DarkBlue
#property indicator_color7 DarkBlue
#property indicator_color8 DarkBlue
//---- input parameters

//---- buffers
double PBuffer[];
double S1Buffer[];
double M2Buffer[];
double S2Buffer[];
double M1Buffer[];
double S3Buffer[];
double M0Buffer[];
double R1Buffer[];
string Pivot="MonthlyPivotPoint",MSup1="M_S 1", MM2="M_M 2";
string MSup2="M_S 2", MM1="M_M 1", MSup3="M_S 3", MM0="M_M 0" ,MRes1="M_R 1";
int fontsize=10;
double P,S1,M2,S2,M1,S3,M0,R1;
double last_month_high, last_month_low, this_month_open, last_month_close;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("WeeklyPivot");
   ObjectDelete("MSup1");
   ObjectDelete("MM2");
   ObjectDelete("MSup2");
   ObjectDelete("MM1");
   ObjectDelete("MSup3");
   ObjectDelete("MM0");  
   ObjectDelete("MRes1"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,3,Magenta);
   SetIndexStyle(1,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(2,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(3,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(4,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(5,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(6,DRAW_LINE,0,3,DarkBlue);
   SetIndexStyle(7,DRAW_LINE,0,3,DarkBlue);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,M2Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,M1Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,M0Buffer);
   SetIndexBuffer(7,R1Buffer);


//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(0,"Monthly Pivot");
   SetIndexLabel(1,"Monthly S1");
   SetIndexLabel(2,"Monthly M2");
   SetIndexLabel(3,"Monthly S2");
   SetIndexLabel(4,"Monthly M1");
   SetIndexLabel(5,"Monthly S3");
   SetIndexLabel(6,"Monthly M0");
   SetIndexLabel(7,"Monthly R1");

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // 1st day of month
	if(TimeDay(Time[i])<=3 && TimeDay(Time[i+1])>=26)
	{
		last_month_close = Close[i+1];
		this_month_open = Open[i];

		// MonthlyPivot
		P = (last_month_high + last_month_low + last_month_close) / 3;

   R1 = (2*P)-last_month_low;
   S1 = (2*P)-last_month_high;
   M2 = (P+S1)/2;
   S2 = P-R1+S1;
   M1 = (S2+S1)/2;
   S3 = (2*P)-((2* last_month_high)-last_month_low);
   M0 = (S3+S2)/2;
  
   last_month_low=Low[i]; last_month_high=High[i];

	ObjectMove("MonthlyPivot", 0, Time[i],P);
   ObjectMove("MSup1", 0, Time[i],S1);
   ObjectMove("MM2", 0, Time[i],M2);
   ObjectMove("MSup2", 0, Time[i],S2);
   ObjectMove("MM1", 0, Time[i],M1);
   ObjectMove("MSup3", 0, Time[i],S3);
   ObjectMove("MM0", 0, Time[i],M0);
   ObjectMove("MRes1", 0, Time[i],R1);

}   
  
      
    last_month_high = MathMax(last_month_high, High[i]);
 	 last_month_low = MathMin(last_month_low, Low[i]);   
    PBuffer[i]=P;
    S1Buffer[i]=S1;
    M2Buffer[i]=M2;
    S2Buffer[i]=S2;
    M1Buffer[i]=M1;
    S3Buffer[i]=S3;
    M0Buffer[i]=M0;
    R1Buffer[i]=R1;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+